// Copyright 2015 Noitom Technology Co., Ltd. All Rights Reserved.

#include "AssetTypeActions_BVH.h"
#include "BVHAsset.h"


#define LOCTEXT_NAMESPACE "AssetTypeActions"

FAssetTypeActions_BVH::FAssetTypeActions_BVH(EAssetTypeCategories::Type InAssetCategoryBit)
: AssetCategoryBit(InAssetCategoryBit)
{
}

FText FAssetTypeActions_BVH::GetName() const
{
	return LOCTEXT("AssetTypeActions_BVH", "BVH");
}

FColor FAssetTypeActions_BVH::GetTypeColor() const
{
	return FColor(128, 100, 200);
}

bool FAssetTypeActions_BVH::HasActions(const TArray<UObject*>& InObjects) const
{
	return false;
}

UClass* FAssetTypeActions_BVH::GetSupportedClass() const
{
	return UBVHAsset::StaticClass();
}

bool FAssetTypeActions_BVH::CanFilter()
{
	return true;
}

uint32 FAssetTypeActions_BVH::GetCategories()
{
	return AssetCategoryBit;
}

#undef LOCTEXT_NAMESPACE