// Copyright 2015 Noitom Technology Co., Ltd. All Rights Reserved.

#pragma once

#include "CoreMinimal.h"
//#include "CoreUObject.h"
#include "Factories/Factory.h"

#include "BVHAssetFactory.generated.h"


class UBVHAsset;

UCLASS(ClassGroup = MotionCapture, hidecategories = Object, MinimalAPI)
class UBVHAssetFactory : public UFactory
{
	GENERATED_BODY()

	UBVHAssetFactory(const FObjectInitializer& ObjectInitializer);

	// UFactory interface
	virtual bool ConfigureProperties() override;
	virtual FName GetNewAssetThumbnailOverride() const override;
	virtual UObject* FactoryCreateNew(UClass* Class, UObject* InParent, FName Name, EObjectFlags Flags, UObject* Context, FFeedbackContext* Warn) override;
	virtual UObject* FactoryCreateBinary(UClass* InClass, UObject* InParent, FName InName, EObjectFlags Flags, UObject* Context, const TCHAR* Type, const uint8*& Buffer, const uint8* BufferEnd, FFeedbackContext* Warn, bool& bOutOperationCanceled) override;
	virtual bool FactoryCanImport(const FString& Filename) override;
	// End of UFactory interface


	/** Holds the title for the browse dialog window. */
	FText BrowseTitle;

	/** Holds the directory path to browse by default. */
	FString BrowseDirectory;

};
