// Copyright 2015 Noitom Technology Co., Ltd. All Rights Reserved.

#include "AnimationData.h"
#include "Hi5BoneLists.h"

namespace Hi5
{

	FAnimationData::FAnimationData( )
	{
		BonePositions.Init( FVector::ZeroVector, MCBONE_NUM );
		BoneRotations.Init( FQuat::Identity, MCBONE_NUM );
	}

	FAnimationData::FAnimationData( FAnimationData&& Other ) :
		bUseRootEffect( Other.bUseRootEffect ),
		RootPosition( Other.RootPosition ),
		RootRotation( Other.RootRotation ),
		bWithDisplacement( Other.bWithDisplacement )
	{
		BonePositions.Init( FVector::ZeroVector, MCBONE_NUM );
		BoneRotations.Init( FQuat::Identity, MCBONE_NUM );

		// Using move semantics
		BonePositions = MoveTemp( Other.BonePositions );
		BoneRotations = MoveTemp( Other.BoneRotations );
	}

	FAnimationData& FAnimationData::operator=( FAnimationData&& Other )
	{
		bUseRootEffect = Other.bUseRootEffect;
		RootPosition = Other.RootPosition;
		RootRotation = Other.RootRotation;
		bWithDisplacement = Other.bWithDisplacement;

		// Using move semantics
		BonePositions = MoveTemp( Other.BonePositions );
		BoneRotations = MoveTemp( Other.BoneRotations );

		return *this;
	}
}
