// Copyright 2015 Noitom Technology Co., Ltd. All Rights Reserved.

#pragma once

#include "CoreMinimal.h"

namespace Hi5
{
	class FAnimationData;

	typedef TSharedPtr<FAnimationData, ESPMode::ThreadSafe> FAnimationDataPtr;


	// Keep standard-layout
	class FAnimationData
	{
	public:
		FAnimationData( );

		FAnimationData( const FAnimationData& ) = default;
		FAnimationData& operator=( const FAnimationData& ) = default;

		FAnimationData( FAnimationData&& );
		FAnimationData& operator=( FAnimationData&& );

	public:

		int32 GloveMode = -1;

		bool bUseRootEffect = false;

		// Reference data
		FVector RootPosition = { 0, 0, 0 };
		FQuat RootRotation = { 0, 0, 0, 1 };

		bool bWithDisplacement = false;

		TArray<FQuat> BoneRotations;
		TArray<FVector> BonePositions;
	};
}
