// Copyright 2015 Noitom Technology Co., Ltd. All Rights Reserved.

#include "EventManager.h"
#include "MotionCaptureComponent.h"


FEventManager* FEventManager::sInstance = nullptr;

FEventManager* FEventManager::GetInstance()
{
	if(!sInstance)
	{
		sInstance = new FEventManager();
	}

	return sInstance;
}

void FEventManager::Tick()
{
	while (!Queue.IsEmpty())
	{
		TSharedPtr<FEventBase> Event = DequeueAppEvent();
		Event->Fire();
	}
}

void FEventManager::EnqueueEvent(const TSharedPtr<FEventBase>& Event)
{
// 	FScopeLock Lock(&CriticalSection);
	Queue.Enqueue(Event);
}

void FEventManager::ClearEventQueue()
{
	while (!Queue.IsEmpty())
	{
		DequeueAppEvent();
	}
}

FEventManager::FEventManager()
{

}

TSharedPtr<FEventBase> FEventManager::DequeueAppEvent()
{
// 	FScopeLock Lock(&CriticalSection);
	TSharedPtr<FEventBase> OutData;
	Queue.Dequeue(OutData);
	return OutData;
}
