// Copyright 2015 Noitom Technology Co., Ltd. All Rights Reserved.

#pragma once

#include "CoreMinimal.h"
#include "EventType.h"
#include "Runtime/Core/Public/Containers/Queue.h"


class FEventManager
{
public:
	static FEventManager* GetInstance();

	void Tick();

	void EnqueueEvent(const TSharedPtr<FEventBase>& Event);

	void ClearEventQueue();

protected:
	FEventManager();

private:
	TSharedPtr<FEventBase> DequeueAppEvent();

	TQueue<TSharedPtr<FEventBase>, EQueueMode::Mpsc> Queue;

// 	FCriticalSection CriticalSection;

	static FEventManager* sInstance;
};
