// Copyright 2015 Noitom Technology Co., Ltd. All Rights Reserved.

#include "EventType.h"
#include "MotionCaptureComponent.h"
#include "MotionCaptureManager.h"


FEventBase::FEventBase()
{

}

FEventBase::FEventBase(EEventType Type) :
EventType(Type)
{

}


FCreateNewEvent::FCreateNewEvent() :
	FEventBase(EEventType::EVENT_TYPE_CREATE)
{

}

FCreateNewEvent::FCreateNewEvent(const TWeakObjectPtr<AMotionCaptureManager>& Manager, const FName& Name, int32 ID, const FVector& InInitPos, const FQuat& InInitQua) :
	FEventBase(EEventType::EVENT_TYPE_CREATE),
	AvatarName(Name),
	AvatarID(ID),
	InitPos(InInitPos),
	InitQua(InInitQua)
{
	OnPNActorEvent().AddUObject(Manager.Get(), &AMotionCaptureManager::CreatePNActor);
}


FMoveToEvent::FMoveToEvent() :
	FEventBase(EEventType::EVENT_TYPE_MOVE)
{

}

#ifndef TRANCE
FMoveToEvent::FMoveToEvent(const TWeakObjectPtr<UMotionCaptureComponent>& InComponent, const FVector& Pos, const FQuat& Qua) :
	FEventBase(EEventType::EVENT_TYPE_MOVE),
	Component(InComponent),
	DestPos(Pos),
	DestQua(Qua)
{
	OnPNActorEvent().AddUObject(Component.Get(), &UMotionCaptureComponent::MoveActorTo);
}
#else
FMoveToEvent::FMoveToEvent(const TWeakObjectPtr<UMotionCaptureAvatarComponent>& InComponent, const FVector& Pos, const FQuat& Qua) :
	FEventBase(EEventType::EVENT_TYPE_MOVE),
	Component(InComponent),
	DestPos(Pos),
	DestQua(Qua)
{
	OnPNActorEvent().AddUObject(Component.Get(), &UMotionCaptureAvatarComponent::MoveActorTo);
}
#endif
