#include "HI5_Calibration.h"
#include "Hi5_Manager_Thread.h"
bool FHI5_Calibration::isCalibratingBPose = false;
bool FHI5_Calibration::isCalibratingPPose =false;
void FHI5_Calibration::ResetCalibration()
{
	if(FHi5_Manager_Thread::getInstance() != nullptr)
		FHi5_Manager_Thread::getInstance()->AddCalibrationCommand(FHI5_Calibration_Command::ECalibration_Command::EPreCalibration);
}

void FHI5_Calibration::StartCalibration(EHI5_Pose pose)
{
	if (pose == EHI5_Pose::BPose)
		isCalibratingBPose = true;

	if (pose == EHI5_Pose::PPose)
		isCalibratingPPose = true;

	if (pose == EHI5_Pose::VPose)
		FHI5_Calibration::ResetCalibration();

	CalibrationPose tranferPose = TransferPoseEnum(pose);

	if (pose == EHI5_Pose::BPose  && FHi5_Manager_Thread::getInstance()!= nullptr)
		FHi5_Manager_Thread::getInstance()->AddCalibrationCommand(FHI5_Calibration_Command::ECalibration_Command::EBCalibration);

	if (pose == EHI5_Pose::PPose  && FHi5_Manager_Thread::getInstance()!= nullptr)
		FHi5_Manager_Thread::getInstance()->AddCalibrationCommand(FHI5_Calibration_Command::ECalibration_Command::EPCalibration);

	if (pose == EHI5_Pose::VPose  && FHi5_Manager_Thread::getInstance()!= nullptr)
		FHi5_Manager_Thread::getInstance()->AddCalibrationCommand(FHI5_Calibration_Command::ECalibration_Command::EVCalibration);
	
}
 CalibrationPose FHI5_Calibration::TransferPoseEnum(EHI5_Pose inputPose)
{
	if (inputPose == EHI5_Pose::BPose)
		return CalibrationPose::GCP_BPose;
	else if (inputPose == EHI5_Pose::PPose)
		return CalibrationPose::GCP_PPose;
	else if (inputPose == EHI5_Pose::VPose)
		return CalibrationPose::GCP_VPose;
	else
		return CalibrationPose::GCP_Unknown;
}

  int FHI5_Calibration::GetCalibrationProgress(EHI5_Pose pose)
{
	CalibrationPose tranferPose = TransferPoseEnum(pose);
	int percent = 0;
	      
	if (pose == EHI5_Pose::BPose && percent == 100)
	{
		isCalibratingBPose = false;
	}
	if (pose == EHI5_Pose::PPose && percent == 100)
	{

		isCalibratingPPose = false;
	}
	if (pose == EHI5_Pose::VPose && percent == 100)
	{

	}
	return percent;

}