// Fill out your copyright notice in the Description page of Project Settings.


#include "Hi5DataTest.h"

TestOptiData::TestOptiData()
{
	sensor1Identity ="";
	sensor1fpos[0] = 0.0f;
	sensor1fpos[1] = 0.0f;
	sensor1fpos[2] = 0.0f;
	sensor1rot[0]  = 0.0f;
	sensor1rot[1]  = 0.0f;
	sensor1rot[2]  = 0.0f;
	sensor1rot[3]  = 0.0f;
	sensor2Identity ="";
	sensor2fpos[0] = 0.0f;
	sensor2fpos[1] = 0.0f;
	sensor2fpos[2] = 0.0f;
	sensor2rot[0] = 0.0f;
	sensor2rot[1] = 0.0f;
	sensor2rot[2] = 0.0f;
	sensor2rot[3] = 0.0f;
}

FHi5DataTest::FHi5DataTest()
{
}

FHi5DataTest::~FHi5DataTest()
{
	
}

void FHi5DataTest::writeOptiData( std::string sensorIdentity,float fpos[3],float frot[4])
{
	if(testOptData.sensor1Identity == sensorIdentity)
	{
		testOptData.sensor1fpos[0] = fpos[0];
		testOptData.sensor1fpos[1] = fpos[1];
		testOptData.sensor1fpos[2] = fpos[2];
		testOptData.sensor1rot[0]  = frot[0];
		testOptData.sensor1rot[1]  = frot[1];
		testOptData.sensor1rot[2]  = frot[2];
		testOptData.sensor1rot[3]  = frot[3];
	}
	else if(testOptData.sensor2Identity == sensorIdentity)
	{
		testOptData.sensor2fpos[0] = fpos[0];
		testOptData.sensor2fpos[1] = fpos[1];
		testOptData.sensor2fpos[2] = fpos[2];
		testOptData.sensor2rot[0]  = frot[0];
		testOptData.sensor2rot[1]  = frot[1];
		testOptData.sensor2rot[2]  = frot[2];
		testOptData.sensor2rot[3]  = frot[3];
	}
	else if(testOptData.sensor1Identity == "")
	{
		testOptData.sensor1Identity = sensorIdentity;
		testOptData.sensor1fpos[0] = fpos[0];
		testOptData.sensor1fpos[1] = fpos[1];
		testOptData.sensor1fpos[2] = fpos[2];
		testOptData.sensor1rot[0]  = frot[0];
		testOptData.sensor1rot[1]  = frot[1];
		testOptData.sensor1rot[2]  = frot[2];
		testOptData.sensor1rot[3]  = frot[3];
	}
	else if(testOptData.sensor2Identity == "")
	{
		testOptData.sensor2Identity = sensorIdentity;
		testOptData.sensor2fpos[0] = fpos[0];
		testOptData.sensor2fpos[1] = fpos[1];
		testOptData.sensor2fpos[2] = fpos[2];
		testOptData.sensor2rot[0]  = frot[0];
		testOptData.sensor2rot[1]  = frot[1];
		testOptData.sensor2rot[2]  = frot[2];
		testOptData.sensor2rot[3]  = frot[3];
	}
}

void FHi5DataTest::writeBindOptic(bool isleft, std::string sensorIdentity)
{
	if(testOptData.sensor1Identity == sensorIdentity)
	{
		if(isleft)
			testOptData.isOneLeft = true;
		else
			testOptData.isOneLeft = false;
	}
	if(testOptData.sensor2Identity == sensorIdentity)
	{
		if(isleft)
			testOptData.isOneLeft = false;
		else
			testOptData.isOneLeft = true;
	}
}

void FHi5DataTest::writeBvhData(bool isleft ,int dataCount,float data[])
{
	if(isleft)
	{
		leftBvhData.dataCount = dataCount;
		for(int i =0;i<dataCount;i++)
		{
			leftBvhData.data[i] = data[i];
		}
	}
	else
	{
		rightBvhData.dataCount = dataCount;
		for(int i =0;i<dataCount;i++)
		{
			rightBvhData.data[i] = data[i];
		}
	}
}



void FHi5DataTest::printOpticData()
{
	 if(testOptData.isOneLeft)
	 {
	 	{
	 		FString logContent;
	 		logContent.Append("leftopt:\n");
	 		logContent.Append("lefttrackername = :");
	 		logContent.Append(testOptData.sensor1Identity.c_str());
	 		logContent.Append("\n");
	 		logContent.Append("fpos = :");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor1fpos[0]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor1fpos[1]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor1fpos[2]));
	 		logContent.Append("\n");
	 		logContent.Append("rot = :");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor1rot[0]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor1rot[1]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor1rot[2]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor1rot[3]));
	 		logContent.Append("\n");
	 		FString TextPath = FPaths::ProjectDir() + TEXT("UE4optLeft.txt");
	 		FFileHelper::SaveStringToFile(logContent, *TextPath);
	 	}
	 
	 	{
	 		FString logContent;
	 		logContent.Append("rightopt:\n");
	 		logContent.Append("righttrackername = :");
	 		logContent.Append(testOptData.sensor2Identity.c_str());
	 		logContent.Append("\n");
	 		logContent.Append("fpos = :");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor2fpos[0]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor2fpos[1]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor2fpos[2]));
	 		logContent.Append("\n");
	 		logContent.Append("rot = :");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor2rot[0]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor2rot[1]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor2rot[2]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor2rot[3]));
	 		logContent.Append("\n");
	 		FString TextPath = FPaths::ProjectDir() + TEXT("UE4optRight.txt");
	 		FFileHelper::SaveStringToFile(logContent, *TextPath);
	 	}
	 	
	 }
	 else
	 {
	 	{
	 		FString logContent;
	 		logContent.Append("leftopt:\n");
	 		logContent.Append("lefttrackername = :");
	 		logContent.Append(testOptData.sensor2Identity.c_str());
	 		logContent.Append("\n");
	 		logContent.Append("fpos = :");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor2fpos[0]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor2fpos[1]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor2fpos[2]));
	 		logContent.Append("\n");
	 		logContent.Append("rot = :");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor2rot[0]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor2rot[1]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor2rot[2]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor2rot[3]));
	 		logContent.Append("\n");
	 		FString TextPath = FPaths::ProjectDir() + TEXT("UE4optLeft.txt");
	 		FFileHelper::SaveStringToFile(logContent, *TextPath);
	 	}
	 	{
	 		FString logContent;
	 		logContent.Append("Rightopt:\n");
	 		logContent.Append("Righttrackername = :");
	 		logContent.Append(testOptData.sensor1Identity.c_str());
	 		logContent.Append("\n");
	 		logContent.Append("fpos = :");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor1fpos[0]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor1fpos[1]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor1fpos[2]));
	 		logContent.Append("\n");
	 		logContent.Append("rot = :");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor1rot[0]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor1rot[1]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor1rot[2]));
	 		logContent.Append(",");
	 		logContent.Append(FString::SanitizeFloat(testOptData.sensor1rot[3]));
	 		logContent.Append("\n");
	 		FString TextPath = FPaths::ProjectDir() + TEXT("UE4optRight.txt");
	 		FFileHelper::SaveStringToFile(logContent, *TextPath);
	 	}
	 }
}
void FHi5DataTest::printleftBvhData()
{
	FString logContent;
	int index = 0;
	logContent.Append("leftBvhdata");
	logContent.Append("\n");
	int a = 0;
	for(int i=0;i<leftBvhData.dataCount;i++)
	{
		logContent.Append( FString::SanitizeFloat(leftBvhData.data[i]));
		logContent.Append(",");
		index++;
		a++;
		if(index == 3)
		{
			logContent.Append("\n");
			index = 0;
		}
		if(a == 6)
		{
			logContent.Append("\n");
			a = 0;
		}
	}
	FString TextPath = FPaths::ProjectDir() + TEXT("UE4leftDatra.txt");
	FFileHelper::SaveStringToFile(logContent, *TextPath);
}
void FHi5DataTest::printRightBvhData()
{
	FString logContent;
	int index = 0;
	int a = 0;
	logContent.Append("rightBvhdata");
	logContent.Append("\n");
	for(int i=0;i<rightBvhData.dataCount;i++)
	{
		logContent.Append( FString::SanitizeFloat(rightBvhData.data[i]));
		logContent.Append(",");
		index++;
		a++;
		if(index == 3)
		{
			logContent.Append("\n");
			index = 0;
		}
		if(a == 6)
		{
			logContent.Append("\n");
			a = 0;
		}
	}
	FString TextPath = FPaths::ProjectDir() + TEXT("UE4rightDatra.txt");
	FFileHelper::SaveStringToFile(logContent, *TextPath);
}