#pragma once

#include "CoreMinimal.h"
#include <stdint.h>

typedef struct _DataHeader
{
	int32_t deviceType;     // 0x01-WII, 0x02-GameSir, 0x03-KeyBoard...
	int32_t version;        // Version of community data format. e.g.: 1
}DataHeader;

// HI5 Glove bvh data
typedef struct _HI5BVHData
{
	DataHeader header;      // 
	char avatarName[64];    // Name of avatar
	int nAvatarIndex;       // Index of avatar
	int bLeftHand;          // 1 = Glove BVH data of left hand, 0 = Glove BVH data of right hand
	int bWithDisp;          // Wether displacement of bone included in bvh
	int frameIndex;         // Frame index
	int dataCount;          // Count of data by float
	float data[160];        // BVH data array. If 'bWithDisp=true', every bone with 6DOF: Xposition Yposition Zposition Yrotation Xrotation Zrotation,
							// otherwise its 3DOF: Yrotation Xrotation Zrotation. The root node is always 6DOF.
}HI5BVHData;

