// Fill out your copyright notice in the Description page of Project Settings.


#include "Hi5_BVHDataQuene.h"
FHi5_status::FHi5_status()
{
	 m_status = EGloveStatus::EUnStatusknown;;
	 ischange = false;
}

void FHi5_status::WriteStatueData(EGloveStatus statue)
{
	std::lock_guard<std::mutex> lck(m_mutex);
	m_status = statue;
	ischange = true;
}

bool FHi5_status::isChange()
{
	std::lock_guard<std::mutex> lck(m_mutex);
		return ischange;
}

EGloveStatus FHi5_status::GetstatusData()
{
	std::lock_guard<std::mutex> lck(m_mutex);   
	ischange = false;
	return m_status;
}

FHi5_BVHDataQuene::FHi5_BVHDataQuene()
{
	m_RightData = new GloveBVHData();
	m_LeftData = new GloveBVHData();
	IsLeftUpdata = false;
	IsRightUpdata= false;
}

FHi5_BVHDataQuene::~FHi5_BVHDataQuene()
{
	{
		std::lock_guard<std::mutex> lck(m_Rightmutex);
		if(m_RightData != nullptr)
		{
			delete m_RightData;
			m_RightData = nullptr;
		}
	}
	
	{
		std::lock_guard<std::mutex> lck(m_Leftmutex);
		if(m_LeftData != nullptr)
		{
			delete m_LeftData;
			m_LeftData = nullptr;
		}
	}
	
}


void FHi5_BVHDataQuene::WriteBvhData(GloveBVHData* inValue)
{ 
	if(inValue != nullptr)
	{
		if(inValue->glove == GloveMod::GM_LeftGlove)
		{
			std::lock_guard<std::mutex> lck(m_Leftmutex);
			if(m_LeftData != nullptr)
			{
				FHi5_BVHDataQuene::SetBvhData(inValue,m_LeftData);
			}
			IsLeftUpdata = true;
		}
		if(inValue->glove == GloveMod::GM_RightGlove)
		{
			std::lock_guard<std::mutex> lck(m_Rightmutex);
			if(m_RightData != nullptr)
			{
				FHi5_BVHDataQuene::SetBvhData(inValue,m_RightData);
			}
			IsRightUpdata = true;
		}
	}
}

void FHi5_BVHDataQuene::SetBvhData(GloveBVHData* inValue, GloveBVHData* outValue)
{
	if(inValue != nullptr && outValue != nullptr)
	{
		outValue->glove = inValue->glove;
		outValue->timeStamp.timeStamp = inValue->timeStamp.timeStamp;
		outValue->timeStamp.latency = inValue->timeStamp.latency;
		outValue->bUpdate = inValue->bUpdate;
		outValue->bWithDisp = inValue->bWithDisp;
		outValue->frameIndex = inValue->frameIndex;
		outValue->dataCount = inValue->dataCount;
		
		for (int i = 0; i < 160; i++)
		{
			outValue->data[i] = inValue->data[i];
		}
	}
}
bool  FHi5_BVHDataQuene::GetBvhtemRight( GloveBVHData* bvhdata)
{
	bool isUpdate = false;
	std::lock_guard<std::mutex> lck(m_Rightmutex);
	{
		SetBvhData(m_RightData,bvhdata);
	
		isUpdate = IsRightUpdata;
		IsRightUpdata = false;
	}
	return isUpdate;
}

bool  FHi5_BVHDataQuene::GetBvhtemLeft( GloveBVHData* bvhdata)
{
	bool isUpdate = false;
	std::lock_guard<std::mutex> lck(m_Leftmutex);
	{
		SetBvhData(m_LeftData,bvhdata);
	
		isUpdate = IsLeftUpdata;
		IsLeftUpdata = false;
	}
	return isUpdate;
}



