// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "UObject/NoExportTypes.h"
#include "Hi5BoneLists.h"
#include "AnimationData.h"
#include "GlovePacketParser.h"
#include "LocalDataReader.generated.h"

/**
 * 
 */
UCLASS()
class ULocalDataReader : public UObject
{
	GENERATED_BODY()
public:
	ULocalDataReader();

	virtual ~ULocalDataReader();

	void OnLocalPlayerBVHDataReceived(const FArrayReaderPtr& Data);
	void OnRemotePlayerBVHDataReceived(const FArrayReaderPtr& Data, const FName& AName);

	int32 GetGloveMode();
	
protected:
	Hi5::FAnimationDataPtr	CurAnimData;

	Hi5::FAnimationDataPtr	CurRemoteAnimData;

	TSharedPtr<Hi5::FGlovePacketParser> PacketParser;
	
};
