// Copyright 2015 Noitom Technology Co., Ltd. All Rights Reserved.

#include "MotionCaptureHelper.h"
#include "Containers/Map.h"
#include "HI5Glove.h"

#if USE_ALICE
#include "../../../../HybridData/Source/HybridData/Public/IHybridData.h"
#endif

namespace Hi5
{
	FMotionCaptureHelper::FMotionCaptureHelper( )
	{
		BoneName2IDMap.Empty( MCBONE_NUM );
		BoneName2IDMap.Add( FName( TEXT( "Hips" ) ), EMCBones::Hips );
		BoneName2IDMap.Add( FName( TEXT( "RightUpLeg" ) ), EMCBones::RightUpLeg );
		BoneName2IDMap.Add( FName( TEXT( "RightLeg" ) ), EMCBones::RightLeg );
		BoneName2IDMap.Add( FName( TEXT( "RightFoot" ) ), EMCBones::RightFoot );
		BoneName2IDMap.Add( FName( TEXT( "LeftUpLeg" ) ), EMCBones::LeftUpLeg );
		BoneName2IDMap.Add( FName( TEXT( "LeftLeg" ) ), EMCBones::LeftLeg );
		BoneName2IDMap.Add( FName( TEXT( "LeftFoot" ) ), EMCBones::LeftFoot );
		BoneName2IDMap.Add( FName( TEXT( "Spine" ) ), EMCBones::Spine );
		BoneName2IDMap.Add( FName( TEXT( "Spine1" ) ), EMCBones::Spine1 );
		BoneName2IDMap.Add( FName( TEXT( "Spine2" ) ), EMCBones::Spine2 );
		BoneName2IDMap.Add( FName( TEXT( "Spine3" ) ), EMCBones::Spine3 );
		BoneName2IDMap.Add( FName( TEXT( "Neck" ) ), EMCBones::Neck );
		BoneName2IDMap.Add( FName( TEXT( "Head" ) ), EMCBones::Head );
		BoneName2IDMap.Add( FName( TEXT( "RightShoulder" ) ), EMCBones::RightShoulder );
		BoneName2IDMap.Add( FName( TEXT( "RightArm" ) ), EMCBones::RightArm );
		BoneName2IDMap.Add( FName( TEXT( "RightForeArm" ) ), EMCBones::RightForeArm );
		BoneName2IDMap.Add( FName( TEXT( "RightHand" ) ), EMCBones::RightHand );
		BoneName2IDMap.Add( FName( TEXT( "RightHandThumb1" ) ), EMCBones::RightHandThumb1 );
		BoneName2IDMap.Add( FName( TEXT( "RightHandThumb2" ) ), EMCBones::RightHandThumb2 );
		BoneName2IDMap.Add( FName( TEXT( "RightHandThumb3" ) ), EMCBones::RightHandThumb3 );
		BoneName2IDMap.Add( FName( TEXT( "RightInHandIndex" ) ), EMCBones::RightInHandIndex );
		BoneName2IDMap.Add( FName( TEXT( "RightInHandIndex1" ) ), EMCBones::RightHandIndex1 );
		BoneName2IDMap.Add( FName( TEXT( "RightInHandIndex2" ) ), EMCBones::RightHandIndex2 );
		BoneName2IDMap.Add( FName( TEXT( "RightInHandIndex3" ) ), EMCBones::RightHandIndex3 );
		BoneName2IDMap.Add( FName( TEXT( "RightInHandMiddle" ) ), EMCBones::RightInHandMiddle );
		BoneName2IDMap.Add( FName( TEXT( "RightInHandMiddle1" ) ), EMCBones::RightHandMiddle1 );
		BoneName2IDMap.Add( FName( TEXT( "RightInHandMiddle2" ) ), EMCBones::RightHandMiddle2 );
		BoneName2IDMap.Add( FName( TEXT( "RightInHandMiddle3" ) ), EMCBones::RightHandMiddle3 );
		BoneName2IDMap.Add( FName( TEXT( "RightInHandRing" ) ), EMCBones::RightInHandRing );
		BoneName2IDMap.Add( FName( TEXT( "RightInHandRing1" ) ), EMCBones::RightHandRing1 );
		BoneName2IDMap.Add( FName( TEXT( "RightInHandRing2" ) ), EMCBones::RightHandRing2 );
		BoneName2IDMap.Add( FName( TEXT( "RightInHandRing3" ) ), EMCBones::RightHandRing3 );
		BoneName2IDMap.Add( FName( TEXT( "RightInHandPinky" ) ), EMCBones::RightInHandPinky );
		BoneName2IDMap.Add( FName( TEXT( "RightInHandPinky1" ) ), EMCBones::RightHandPinky1 );
		BoneName2IDMap.Add( FName( TEXT( "RightInHandPinky2" ) ), EMCBones::RightHandPinky2 );
		BoneName2IDMap.Add( FName( TEXT( "RightInHandPinky3" ) ), EMCBones::RightHandPinky3 );
		BoneName2IDMap.Add( FName( TEXT( "LeftShoulder" ) ), EMCBones::LeftShoulder );
		BoneName2IDMap.Add( FName( TEXT( "LeftArm" ) ), EMCBones::LeftArm );
		BoneName2IDMap.Add( FName( TEXT( "LeftForeArm" ) ), EMCBones::LeftForeArm );
		BoneName2IDMap.Add( FName( TEXT( "LeftHand" ) ), EMCBones::LeftHand );
		BoneName2IDMap.Add( FName( TEXT( "LeftHandThumb1" ) ), EMCBones::LeftHandThumb1 );
		BoneName2IDMap.Add( FName( TEXT( "LeftHandThumb2" ) ), EMCBones::LeftHandThumb2 );
		BoneName2IDMap.Add( FName( TEXT( "LeftHandThumb3" ) ), EMCBones::LeftHandThumb3 );
		BoneName2IDMap.Add( FName( TEXT( "LeftInHandIndex" ) ), EMCBones::LeftInHandIndex );
		BoneName2IDMap.Add( FName( TEXT( "LeftInHandIndex1" ) ), EMCBones::LeftHandIndex1 );
		BoneName2IDMap.Add( FName( TEXT( "LeftInHandIndex2" ) ), EMCBones::LeftHandIndex2 );
		BoneName2IDMap.Add( FName( TEXT( "LeftInHandIndex3" ) ), EMCBones::LeftHandIndex3 );
		BoneName2IDMap.Add( FName( TEXT( "LeftInHandMiddle" ) ), EMCBones::LeftInHandMiddle );
		BoneName2IDMap.Add( FName( TEXT( "LeftInHandMiddle1" ) ), EMCBones::LeftHandMiddle1 );
		BoneName2IDMap.Add( FName( TEXT( "LeftInHandMiddle2" ) ), EMCBones::LeftHandMiddle2 );
		BoneName2IDMap.Add( FName( TEXT( "LeftInHandMiddle3" ) ), EMCBones::LeftHandMiddle3 );
		BoneName2IDMap.Add( FName( TEXT( "LeftInHandRing" ) ), EMCBones::LeftInHandRing );
		BoneName2IDMap.Add( FName( TEXT( "LeftInHandRing1" ) ), EMCBones::LeftHandRing1 );
		BoneName2IDMap.Add( FName( TEXT( "LeftInHandRing2" ) ), EMCBones::LeftHandRing2 );
		BoneName2IDMap.Add( FName( TEXT( "LeftInHandRing3" ) ), EMCBones::LeftHandRing3 );
		BoneName2IDMap.Add( FName( TEXT( "LeftInHandPinky" ) ), EMCBones::LeftInHandPinky );
		BoneName2IDMap.Add( FName( TEXT( "LeftInHandPinky1" ) ), EMCBones::LeftHandPinky1 );
		BoneName2IDMap.Add( FName( TEXT( "LeftInHandPinky2" ) ), EMCBones::LeftHandPinky2 );
		BoneName2IDMap.Add( FName( TEXT( "LeftInHandPinky3" ) ), EMCBones::LeftHandPinky3 );
	}

	FMotionCaptureHelper::~FMotionCaptureHelper( )
	{

	}

	int8 FMotionCaptureHelper::GetInt8( const uint8* Data, int32& Offset )
	{
		const int8* pInt = (const int8*)(Data + Offset);
		Offset += sizeof( int8 );
		return *pInt;
	}

	uint8 FMotionCaptureHelper::GetUInt8( const uint8* Data, int32& Offset )
	{
		const uint8* pInt = Data + Offset;
		Offset += sizeof( uint8 );
		return *pInt;
	}

	int16 FMotionCaptureHelper::GetInt16( const uint8* Data, int32& Offset )
	{
		uint8 Value[2];
		int16* pInt;
		Value[0] = Data[Offset + 0];
		Value[1] = Data[Offset + 1];
		pInt = (int16*)Value;
		Offset += sizeof( int16 );
		return *pInt;
	}

	uint16 FMotionCaptureHelper::GetUInt16( const uint8* Data, int32& Offset )
	{
		uint8 Value[2];
		uint16* pInt;
		Value[0] = Data[Offset + 0];
		Value[1] = Data[Offset + 1];
		pInt = (uint16*)Value;
		Offset += sizeof( uint16 );
		return *pInt;
	}

	int32 FMotionCaptureHelper::GetInt32( const uint8* Data, int32& Offset )
	{
		uint8 Value[4];
		int32* pInt;
		Value[0] = Data[Offset + 0];
		Value[1] = Data[Offset + 1];
		Value[2] = Data[Offset + 2];
		Value[3] = Data[Offset + 3];
		pInt = (int32*)Value;
		Offset += sizeof( int32 );
		return *pInt;
	}

	uint32 FMotionCaptureHelper::GetUInt32( const uint8* Data, int32& Offset )
	{
		uint8 Value[4];
		uint32* pInt;
		Value[0] = Data[Offset + 0];
		Value[1] = Data[Offset + 1];
		Value[2] = Data[Offset + 2];
		Value[3] = Data[Offset + 3];
		pInt = (uint32*)Value;
		Offset += sizeof( uint32 );
		return *pInt;
	}

	float FMotionCaptureHelper::GetFloat( const uint8* Data, int32& Offset )
	{
		uint8 Value[4];
		float* pFloat;
		Value[0] = Data[Offset + 0];
		Value[1] = Data[Offset + 1];
		Value[2] = Data[Offset + 2];
		Value[3] = Data[Offset + 3];
		pFloat = (float*)Value;
		Offset += sizeof( float );
		return *pFloat;
	}

	double FMotionCaptureHelper::GetDouble( const uint8* Data, int32& Offset )
	{
		uint8 Value[8];
		double* pDouble;
		Value[0] = Data[Offset + 0];
		Value[1] = Data[Offset + 1];
		Value[2] = Data[Offset + 2];
		Value[3] = Data[Offset + 3];
		Value[4] = Data[Offset + 4];
		Value[5] = Data[Offset + 5];
		Value[6] = Data[Offset + 6];
		Value[7] = Data[Offset + 7];
		pDouble = (double*)Value;
		Offset += sizeof( double );
		return *pDouble;
	}

	FString FMotionCaptureHelper::GetString( const uint8* Data, int32& Offset, const int32 StringLength )
	{
		FString Str( StringLength, ANSI_TO_TCHAR( (char*)(Data + Offset) ) );
		Offset += sizeof( char ) * StringLength;
		return Str;
	}

	FVector FMotionCaptureHelper::GetPosition( const uint8* Data, int32& Offset )
	{
		FVector Pos;
		Pos.Y = -GetFloat( Data, Offset );
		Pos.Z = GetFloat( Data, Offset );
		Pos.X = GetFloat( Data, Offset );
		return Pos;
	}

	FQuat FMotionCaptureHelper::GetQuaternion( const uint8* Data, int32& Offset )
	{
		float vy = GetFloat( Data, Offset );
		float vx = GetFloat( Data, Offset );
		float vz = GetFloat( Data, Offset );

		return FRotator( -vx, -vy, vz ).Quaternion( );

		//rg
		//float vz = GetFloat( Data, Offset );
		//float vy = -GetFloat( Data, Offset );
		//float vx = -GetFloat( Data, Offset );
		//return  FRotator(vx, vy, vz).Quaternion();
	}

	FQuat FMotionCaptureHelper::GetQuaternion( float Data0, float Data1, float Data2 )
	{
		float Z = -Data0;
		float X = -Data1;
		float Y = -Data2;

		return CalcQuaternion( X, Y, Z );
	}

	FQuat FMotionCaptureHelper::CalcQuaternion( float X, float Y, float Z )
	{
		return FQuat( FVector( 0, 0, 1 ), FMath::DegreesToRadians( Z ) ) *
			FQuat( FVector( 1, 0, 0 ), FMath::DegreesToRadians( X ) ) *
			FQuat( FVector( 0, 1, 0 ), FMath::DegreesToRadians( Y ) );
	}

	FVector FMotionCaptureHelper::GetVivePosition( const uint8* Data, int32& Offset )
	{
		FVector Pos;
		//原始
		 Pos.Y = GetFloat( Data, Offset );
		 Pos.Z = GetFloat( Data, Offset );
		 Pos.X = -GetFloat( Data, Offset );

		/*Pos.Z = -GetFloat( Data, Offset ) ;
		Pos.Y = GetFloat( Data, Offset ) ;
		Pos.X = GetFloat( Data, Offset ) ;*/
		// Pos.X = GetFloat( Data, Offset );
		// Pos.Y = GetFloat( Data, Offset );
		// Pos.Z = GetFloat( Data, Offset );
		return Pos;
	}

	 void FMotionCaptureHelper::Test(const uint8* Data,int32 Offset)
	{
		int32 testPos = Offset;
		FString logContent;
		float testData[126];
		//memset(testData,'0',sizeof(float)*126);
		memcpy(testData,Data,sizeof(testData));
		int index = 0;
		while(testPos<126)
		{
			float a = GetFloat(Data,testPos);
			logContent.Append( FString::SanitizeFloat(a));
			logContent.Append(",");
			index++;
			if(index == 3)
			{
				logContent.Append("\n");
				index = 0;
			}
		}
		FString TextPath = FPaths::ProjectDir() + TEXT("uE4DATA.txt");
		FFileHelper::SaveStringToFile(logContent, *TextPath);
	}

	FVector FMotionCaptureHelper::GetAlicePosition( const uint8* Data, int32& Offset, UObject* PawnObj )
	{
		FVector OutPos;
#if USE_ALICE
		if (IHybridData::GetPtr( )) {
			FVector Pos;
			Pos.X = GetFloat( Data, Offset );
			Pos.Y = GetFloat( Data, Offset );
			Pos.Z = GetFloat( Data, Offset );

			AliceIns( ).GetHybridDataPostion( Pos, OutPos, PawnObj );
		}
#endif // USE_ALICE
		return OutPos;
	}

	FQuat FMotionCaptureHelper::GetViveQuaternion( const uint8* Data, int32& Offset )
	{
		//
		//float vy = GetFloat( Data, Offset );
		//float vx = GetFloat( Data, Offset );
		//float vz = GetFloat( Data, Offset );

		//return FQuat(FVector(0, 0, 1), FMath::DegreesToRadians(-180)) * FRotator(-vx, -vy, vz).Quaternion();
		/*return FQuat(FVector(0, 0, 1), FMath::DegreesToRadians(-180)) * FRotator(-vx, -vy, vz).Quaternion();*/
		//rg
		float vy = GetFloat( Data, Offset );
		float vx = GetFloat( Data, Offset );
		float vz = GetFloat( Data, Offset );
		//return FRotator(-vx, -vy, vz).Quaternion();
		//vy = 0.0f;
		//vx = 0.0f;
		return FQuat(FVector(0, 0, 1), FMath::DegreesToRadians(-180)) * FRotator(-vx, -vy, vz).Quaternion();
		/*return FQuat(FVector(0, 0, 1), FMath::DegreesToRadians(-90)) * FRotator(-vx, -vy, vz).Quaternion() * FQuat(FVector(0, 0, 1), FMath::DegreesToRadians(-90));*/
		//return  FRotator(vx, vy, vz).Quaternion();
		// float vy = GetFloat( Data, Offset );
		// float vx = GetFloat( Data, Offset )+180.0f;
		// if(vx > 360)
		// {
		// 	vx = vx -180.0f;
		// }
		// float vz = GetFloat( Data, Offset );
		// return FRotator(-vx, -vy, vz).Quaternion();;
		//return FQuat(FVector(0, 0, 1), FMath::DegreesToRadians(-180)) * FRotator(-vx, -vy, vz).Quaternion();
		/*
		float vz = -GetFloat(Data, Offset);
		float vy = GetFloat(Data, Offset);
		float vx = -GetFloat(Data, Offset);
		//return FRotator(vx, vy, vz).Quaternion();
		return FQuat(FVector(0, 0, 1), FMath::DegreesToRadians(-180)) * FRotator(vx, vy, vz).Quaternion();
*/
		
		//return FQuat( FVector( 0, 0, 1 ), FMath::DegreesToRadians( -180 ) ) * FRotator( -vx, -vy, vz ).Quaternion( );
		//return FQuat (FVector (0, 0, 1), FMath::DegreesToRadians (-90)) * FRotator (-vx, -vy, vz).Quaternion () * FQuat (FVector (0, 0, 1), FMath::DegreesToRadians (-90));
	}

	FQuat FMotionCaptureHelper::GetAliceQuaternion( const uint8* Data, int32& Offset, UObject* PawnObj )
	{
		FQuat OutQuat;
#if USE_ALICE
		if (IHybridData::GetPtr( )) {
			float ay = GetFloat( Data, Offset );
			float ax = GetFloat( Data, Offset );
			float az = GetFloat( Data, Offset );

			// 求该Motive欧拉角在unreal里的四元数对应表示
			FQuat Q_unreal = FRotator( -ax, -ay, az ).Quaternion( );	// UE4里，此处X定义为前、Z为上
			Q_unreal = FRotator( 0, 90, 0 ).Quaternion( ) * Q_unreal;// UE4里，此处Y定义为前、Z为上

			// 将Y为前、Z为上的UE4四元数变换为Motive坐标系里的Z为前、Y为上的四元数。
			FQuat Q_Alice( Q_unreal.X, Q_unreal.Z, Q_unreal.Y, -Q_unreal.W );

			// HybridData期待的数据：Motive过来的变换为UE4里面Y轴朝前的。
			AliceIns( ).GetHybridDataRotator( Q_Alice, OutQuat, PawnObj );
		}
#endif // USE_ALICE
		return OutQuat;
	}


	// The bone count should be received from network, but Noitom`s protocol doesn`t provide this.
	const uint8 FMotionCaptureHelper::PNBoneCount = 59;

	// The order is important
	const EMCBones::Type FMotionCaptureHelper::PNBoneIndices[] = {
		EMCBones::Hips,
		EMCBones::RightUpLeg,
		EMCBones::RightLeg,
		EMCBones::RightFoot,
		EMCBones::LeftUpLeg,
		EMCBones::LeftLeg,
		EMCBones::LeftFoot,
		EMCBones::Spine,
		EMCBones::Spine1,
		EMCBones::Spine2,
		EMCBones::Spine3,
		EMCBones::Neck,
		EMCBones::Head,
		EMCBones::RightShoulder,
		EMCBones::RightArm,
		EMCBones::RightForeArm,
		EMCBones::RightHand,
		EMCBones::RightHandThumb1,
		EMCBones::RightHandThumb2,
		EMCBones::RightHandThumb3,
		EMCBones::RightInHandIndex,
		EMCBones::RightHandIndex1,
		EMCBones::RightHandIndex2,
		EMCBones::RightHandIndex3,
		EMCBones::RightInHandMiddle,
		EMCBones::RightHandMiddle1,
		EMCBones::RightHandMiddle2,
		EMCBones::RightHandMiddle3,
		EMCBones::RightInHandRing,
		EMCBones::RightHandRing1,
		EMCBones::RightHandRing2,
		EMCBones::RightHandRing3,
		EMCBones::RightInHandPinky,
		EMCBones::RightHandPinky1,
		EMCBones::RightHandPinky2,
		EMCBones::RightHandPinky3,
		EMCBones::LeftShoulder,
		EMCBones::LeftArm,
		EMCBones::LeftForeArm,
		EMCBones::LeftHand,
		EMCBones::LeftHandThumb1,
		EMCBones::LeftHandThumb2,
		EMCBones::LeftHandThumb3,
		EMCBones::LeftInHandIndex,
		EMCBones::LeftHandIndex1,
		EMCBones::LeftHandIndex2,
		EMCBones::LeftHandIndex3,
		EMCBones::LeftInHandMiddle,
		EMCBones::LeftHandMiddle1,
		EMCBones::LeftHandMiddle2,
		EMCBones::LeftHandMiddle3,
		EMCBones::LeftInHandRing,
		EMCBones::LeftHandRing1,
		EMCBones::LeftHandRing2,
		EMCBones::LeftHandRing3,
		EMCBones::LeftInHandPinky,
		EMCBones::LeftHandPinky1,
		EMCBones::LeftHandPinky2,
		EMCBones::LeftHandPinky3,
	};

	// The order is important
	const EMCBones::Type FMotionCaptureHelper::PNBoneParentIndices[] = {
		EMCBones::Invalid,
		EMCBones::Hips,
		EMCBones::RightUpLeg,
		EMCBones::RightLeg,
		EMCBones::Hips,
		EMCBones::LeftUpLeg,
		EMCBones::LeftLeg,
		EMCBones::Hips,
		EMCBones::Spine,
		EMCBones::Spine1,
		EMCBones::Spine2,
		EMCBones::Spine3,
		EMCBones::Neck,
		EMCBones::Spine3,
		EMCBones::RightShoulder,
		EMCBones::RightArm,
		EMCBones::RightForeArm,
		EMCBones::RightHand,
		EMCBones::RightHandThumb1,
		EMCBones::RightHandThumb2,
		EMCBones::RightHand,
		EMCBones::RightInHandIndex,
		EMCBones::RightHandIndex1,
		EMCBones::RightHandIndex2,
		EMCBones::RightHand,
		EMCBones::RightInHandMiddle,
		EMCBones::RightHandMiddle1,
		EMCBones::RightHandMiddle2,
		EMCBones::RightHand,
		EMCBones::RightInHandRing,
		EMCBones::RightHandRing1,
		EMCBones::RightHandRing2,
		EMCBones::RightHand,
		EMCBones::RightInHandPinky,
		EMCBones::RightHandPinky1,
		EMCBones::RightHandPinky2,
		EMCBones::Spine3,
		EMCBones::LeftShoulder,
		EMCBones::LeftArm,
		EMCBones::LeftForeArm,
		EMCBones::LeftHand,
		EMCBones::LeftHandThumb1,
		EMCBones::LeftHandThumb2,
		EMCBones::LeftHand,
		EMCBones::LeftInHandIndex,
		EMCBones::LeftHandIndex1,
		EMCBones::LeftHandIndex2,
		EMCBones::LeftHand,
		EMCBones::LeftInHandMiddle,
		EMCBones::LeftHandMiddle1,
		EMCBones::LeftHandMiddle2,
		EMCBones::LeftHand,
		EMCBones::LeftInHandRing,
		EMCBones::LeftHandRing1,
		EMCBones::LeftHandRing2,
		EMCBones::LeftHand,
		EMCBones::LeftInHandPinky,
		EMCBones::LeftHandPinky1,
		EMCBones::LeftHandPinky2,

	};

	TMap<FName, TEnumAsByte<EMCBones::Type>> FMotionCaptureHelper::BoneName2IDMap;


	static FMotionCaptureHelper AnimDataParser;
}