// Copyright 2015 Noitom Technology Co., Ltd. All Rights Reserved.

#pragma once

#include "CoreMinimal.h"
#include "Hi5BoneLists.h"

namespace Hi5
{
	class MOTIONCAPTURERUNTIME_API FMotionCaptureHelper
	{
	public:
		FMotionCaptureHelper( );
		virtual ~FMotionCaptureHelper( );

		static int8 GetInt8( const uint8* Data, int32& Offset );
		static uint8 GetUInt8( const uint8* Data, int32& Offset );

		static int16 GetInt16( const uint8* Data, int32& Offset );
		static uint16 GetUInt16( const uint8* Data, int32& Offset );

		static int32 GetInt32( const uint8* Data, int32& Offset );
		static uint32 GetUInt32( const uint8* Data, int32& Offset );

		static float GetFloat( const uint8* Data, int32& Offset );
		static double GetDouble( const uint8* Data, int32& Offset );

		static FString GetString( const uint8* Data, int32& Offset, const int32 StringLength );

		static FVector GetPosition( const uint8* Data, int32& Offset );
		static FVector GetVivePosition( const uint8* Data, int32& Offset );
		static FVector GetAlicePosition( const uint8* Data, int32& Offset, UObject* PawnObj = nullptr );

		static FQuat GetQuaternion( const uint8* Data, int32& Offset );
		static FQuat GetViveQuaternion( const uint8* Data, int32& Offset );
		static FQuat GetAliceQuaternion( const uint8* Data, int32& Offset, UObject* PawnObj = nullptr );
		static FQuat GetQuaternion( float Data0, float Data1, float Data2 );

		const static uint8 PNBoneCount;
		const static EMCBones::Type PNBoneIndices[];
		const static EMCBones::Type PNBoneParentIndices[];

		static TMap<FName, TEnumAsByte<EMCBones::Type>> BoneName2IDMap;
		static void Test(const uint8* Data,int32 Offset);
	private:
		static FQuat CalcQuaternion( float X, float Y, float Z );

	};
}
