// Copyright 2015 Noitom Technology Co., Ltd. All Rights Reserved.

#pragma once

#include "CoreMinimal.h"
#include "Hi5BoneLists.h"
#include "AnimationData.h"
#include "Hi5PacketParser.h"
#include "Common/UdpSocketBuilder.h"

#include "MotionCaptureNetwork.generated.h"


UCLASS(ClassGroup = MotionCapture, NotBlueprintable, Transient)
class UMotionCaptureNetwork : public UObject
{
	GENERATED_BODY()

public:
	UMotionCaptureNetwork();

	virtual ~UMotionCaptureNetwork();

	bool Connect();

	void DisConnect();

	// added from version 1.1
	bool Connect(const FString& IP, int32 Port);

protected:
	void UdpReceivedCallback(const FArrayReaderPtr& Data, const FIPv4Endpoint& IP);


	Hi5::FAnimationDataPtr	CurAnimData;

	TSharedPtr<Hi5::FPacketParser> PacketParser;

	TSharedPtr<FSocket> UDPSocket;
	TSharedPtr<FUdpSocketReceiver> UDPReceiver;
};
