// Copyright 2015 Noitom Technology Co., Ltd. All Rights Reserved.

#include "MotionCaptureSpawner.h"


#if WITH_EDITOR
/** Returns SpriteComponent subobject **/
UBillboardComponent* AMotionCaptureSpawner::GetSpriteComponent() const { return SpriteComponent; }
/** Returns TextRenderComponent subobject **/
UTextRenderComponent* AMotionCaptureSpawner::GetTextRenderComponent() const { return TextRenderComponent; }
#endif


AMotionCaptureSpawner::AMotionCaptureSpawner(const FObjectInitializer& ObjectInitializer)
: Super(ObjectInitializer)
{
	USceneComponent* SceneComponent = CreateDefaultSubobject<USceneComponent>(TEXT("SceneComp"));
	RootComponent = SceneComponent;

#if WITH_EDITOR
	SpriteComponent = CreateEditorOnlyDefaultSubobject<UBillboardComponent>(TEXT("Sprite"));
// 	TextRenderComponent = CreateEditorOnlyDefaultSubobject<UTextRenderComponent>(TEXT("Text"));

	if (!IsRunningCommandlet())
	{
		// Structure to hold one-time initialization
		struct FConstructorStatics
		{
			ConstructorHelpers::FObjectFinderOptional<UTexture2D> StartPointIconObject;
			FName ID_StartPoint;
			FText NAME_StartPoint;
			FConstructorStatics()
				: StartPointIconObject(TEXT("/MotionCapture/Icons/StartPointIcon"))
				, ID_StartPoint(TEXT("Misc"))
				, NAME_StartPoint(NSLOCTEXT("SpriteCategory", "Misc", "Misc"))
			{
			}
		};
		static FConstructorStatics ConstructorStatics;

		if (SpriteComponent)
		{
			SpriteComponent->Sprite = ConstructorStatics.StartPointIconObject.Get();
#if ENGINE_MAJOR_VERSION == 4 && ENGINE_MINOR_VERSION < 24
			SpriteComponent->RelativeScale3D = FVector( 0.55f, 0.55f, 0.55f );
#else
			SpriteComponent->SetRelativeScale3D( FVector( 0.55f, 0.55f, 0.55f ) );
#endif
			SpriteComponent->SpriteInfo.Category = ConstructorStatics.ID_StartPoint;
			SpriteComponent->SpriteInfo.DisplayName = ConstructorStatics.NAME_StartPoint;
			SpriteComponent->bIsScreenSizeScaled = true;
			SpriteComponent->SetupAttachment(SceneComponent);
			SpriteComponent->SetRelativeLocation(FVector(.0f, .0f, 10.0f));
		}
	}
#endif // WITH_EDITOR

#if ENGINE_MAJOR_VERSION == 4 && ENGINE_MINOR_VERSION < 24
	bHidden = true;
	bCanBeDamaged = false;
#else
	SetActorHiddenInGame( true );
	SetCanBeDamaged( false );
#endif
}

AMotionCaptureSpawner::~AMotionCaptureSpawner()
{

}
