// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"

class UMotionCaptureNetwork;
class ULocalDataReader;


/**
 * 
 */
class NetworkManager
{
public:
	NetworkManager();
	~NetworkManager();

	static NetworkManager* GetInstance();

	bool Connect(const FString& IP="0.0.0.0", int32 Port=7002);
	void Disconnect();

	void InitLocalDataReader();

	void OnLocalPlayerBVHDataReceived(const FArrayReaderPtr& Data);
	void OnLocalPlayerBVHDataReceived(const uint8* pData, int DataLen);
	void OnRemotePlayerBVHDataReceived(const FArrayReaderPtr& Data,const FName& AvatarName);

	int32 GetGloveMode();
private:
	static NetworkManager* Instance;
	UMotionCaptureNetwork* Network = nullptr;
	ULocalDataReader* LocalDataReader = nullptr;

	
};
