// Copyright 2015 Noitom Technology Co., Ltd. All Rights Reserved.

#include "PNThreadingBase.h"


namespace Hi5
{
	void FPNMultiReaderSingleWriter::LockRead( )
	{
		{
			SCOPE_CYCLE_COUNTER( STAT_Sleep );

			FThreadIdleStats::FScopeIdle Scope;
			while (!CanRead( ))
			{
				FPlatformProcess::SleepNoStats( 0.0f );
			}
		}
		CriticalSection.ReadCounter.Increment( );
	}

	void FPNMultiReaderSingleWriter::UnlockRead( )
	{
		if (0 == CriticalSection.ReadCounter.Decrement( ))
		{
			FPlatformAtomics::InterlockedExchange( &CriticalSection.Action, NoAction );
		}
	}

	void FPNMultiReaderSingleWriter::LockWrite( )
	{
		{
			SCOPE_CYCLE_COUNTER( STAT_Sleep );

			FThreadIdleStats::FScopeIdle Scope;
			while (!CanWrite( ))
			{
				FPlatformProcess::SleepNoStats( 0.0f );
			}
		}

		CriticalSection.WriteCounter.Increment( );
	}

	void FPNMultiReaderSingleWriter::UnlockWrite( )
	{
		if (0 == CriticalSection.WriteCounter.Decrement( ))
		{
			FPlatformAtomics::InterlockedExchange( &CriticalSection.Action, NoAction );
		}
	}
}
