// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include <mutex>
#include "HI5Glove/HI5Glove_C.h"

using namespace HI5Device;


enum EMagneticStatus
{
    EMagneticStatusUnknown = -1,
    EMagneticStatusGood = 0,
    EMagneticStatusFair,
    EMagneticStatusBad,
    EMagneticStatusNone,
};

class MOTIONCAPTURERUNTIME_API FHI5_MagneticStatus  : public std::enable_shared_from_this<FHI5_MagneticStatus>
{
public:
	FHI5_MagneticStatus();
	virtual ~FHI5_MagneticStatus();
    void SetLeftStatus(EMagneticStatus inValue);
    EMagneticStatus GetLeftStatus();
    void SetRightStatus(EMagneticStatus inValue);
    EMagneticStatus GetRightStatus();
    void Update(float detatime);
    void RemoveDongle();
    void OnEventChanged(GloveMod gloveMod, GloveEvent gloveEvent);
private:
    mutable  std::mutex m_leftMut;
    mutable  std::mutex m_rightMut;
    EMagneticStatus m_StatusLeft;
    EMagneticStatus m_StatusRight;
    static  float cd;
    float leftCd ;
    float rightCd;
};