// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "HI5Glove/HI5Glove_C.h"
using namespace HI5Device;
/**
 * 
 */
 enum EHi5Bones
 {
 	EHi5ForeArm = 0,
 	EHi5HandBone = 1,
 	EHi5HandThumb1,
 	EHi5HandThumb2,
 	EHi5HandThumb3,
 	EHi5InHandIndex,
 	EHi5HandIndex1,
 	EHi5HandIndex2,
 	EHi5HandIndex3,
 	EHi5InHandMiddle,
 	EHi5HandMiddle1,
 	EHi5HandMiddle2,
 	EHi5HandMiddle3,
 	EHi5InHandRing,
 	EHi5HandRing1,
 	EHi5HandRing2,
 	EHi5HandRing3,
 	EHi5InHandPinky,
 	EHi5HandPinky1,
 	EHi5HandPinky2,
 	EHi5HandPinky3,
 	EHi5NumOfHI5Bones,
 };
 enum EHI5Hand
{
	ELEFT = 0,
	ERIGHT,
};

class MOTIONCAPTURERUNTIME_API FHi5Source : public std::enable_shared_from_this<FHi5Source>
{
public:
	FHi5Source();
	~FHi5Source();
	FVector GetReceivedPosition(int boneIndex, EHI5Hand handType);
	FVector GetReceivedRotation(int boneIndex, EHI5Hand handType);
	void UpdateTrackingData(GloveBVHData& gloveData);
private:
	void ResetData(FVector* bones) ;
private:
	FVector L_BonePos[EHi5Bones::EHi5NumOfHI5Bones];
	FVector R_BonePos[EHi5Bones::EHi5NumOfHI5Bones];
	FVector L_BoneRot[EHi5Bones::EHi5NumOfHI5Bones];
	FVector R_BoneRot[EHi5Bones::EHi5NumOfHI5Bones];
	std::string AvatarName;
	bool withDisp;
};
