// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include <mutex>
#include "HI5Glove/HI5Glove_C.h"
#include "Hi5GloveDataType.h"
using namespace HI5Device;
/**
 * 
 */
enum EGloveStatus
{
	EUnStatusknown = -1,
	EGloveStatusNoDongle,
	EGloveStatusNoGlove,
	EGloveStatusLeftGloveAvailable,
	EGloveStatusRightGloveAvailable,
	EGloveStatusBothGloveAvailable,
};

 class  MOTIONCAPTURERUNTIME_API FHi5_status : public std::enable_shared_from_this<FHi5_status>
{
 public:
 	FHi5_status();
 	void WriteStatueData(EGloveStatus statue);
 	bool isChange();
 	EGloveStatus GetstatusData();
 private:
 	std::mutex	m_mutex;
 	EGloveStatus m_status;
 	bool ischange ;
};

class MOTIONCAPTURERUNTIME_API FHi5_BVHDataQuene : public std::enable_shared_from_this<FHi5_BVHDataQuene>
{
public:
	FHi5_BVHDataQuene();
	~FHi5_BVHDataQuene();
	
	void WriteBvhData(GloveBVHData* inValue);
	bool  GetBvhtemRight( GloveBVHData* bvhdata);
	bool  GetBvhtemLeft( GloveBVHData* bvhdata);
	static void SetBvhData(GloveBVHData* inValue, GloveBVHData* outValue);
private:
	GloveBVHData* m_RightData;
	GloveBVHData*  m_LeftData;
	std::mutex	m_Leftmutex;
	std::mutex  m_Rightmutex;
	bool IsLeftUpdata;
	bool IsRightUpdata;
};
